///--------------------------------------------------------------------------------------
//	SpriteCompiler.h
//
//	Portions are copyright:  1991-94 Tony Myles, All rights reserved worldwide.
//
//	Description:	constants, structures, and prototypes for the sprite compiler
///--------------------------------------------------------------------------------------


#ifndef __SPRITECOMPILER__
#define __SPRITECOMPILER__

#ifndef __SWCOMMON__
#include "SWCommonHeaders.h"
#endif

#ifndef __SPRITEFRAME__
#include "SpriteFrame.h"
#endif

#ifndef __SPRITE__
#include "Sprite.h"
#endif

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif



#define	kMaxInstructionSize 8


#ifdef __cplusplus
extern "C" {
#endif

SW_FUNC OSErr SWCompileSprite(
	SpritePtr srcSpriteP);

SW_FUNC OSErr SWCompileFrame(
	FramePtr srcFrameP);

SW_FUNC OSErr SWParsePixels(
	Ptr maskStartAddrP,
	Rect* frameRect,
	unsigned long numBytesPerRow,
	PixelCodeHdl* newPixCodeH);

SW_FUNC OSErr SWCompileMaskScanLine(
	PixelCodeHdl newPixCodeH,
	Ptr maskPixelP,
	long numberOfPixels,
	Boolean isLastScanLine);

SW_FUNC OSErr SWGeneratePreamble(
	PixelCodeHdl srcPixCodeH);

SW_FUNC OSErr SWGeneratePostamble(
	PixelCodeHdl srcPixCodeH);

#ifdef __cplusplus
}
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#endif	/* __SPRITECOMPILER__ */
