unit Scrolling;

interface

	uses
{$IFC undefined THINK_Pascal}
		Types, 
{$ENDC}
		SWCommonHeaders, Sprite, SpriteFrame, SpriteWorld;

{/--------------------------------------------------------------------------------------}
{	Scrolling.h}
{}
{	By: Vern Jensen 8/29/95}
{/--------------------------------------------------------------------------------------}

{/--------------------------------------------------------------------------------------}
{	scrolling function prototypes}
{/--------------------------------------------------------------------------------------}

{$PUSH}
{$ALIGN MAC68K}


	procedure SWUpdateScrollingWindow (spriteWorldP: SpriteWorldPtr);
	procedure SWUpdateScrollingSpriteWorld (spriteWorldP: SpriteWorldPtr; updateWindow: Boolean);
	procedure SWProcessScrollingSpriteWorld (spriteWorldP: SpriteWorldPtr);
	procedure SWAnimateScrollingSpriteWorld (spriteWorldP: SpriteWorldPtr);

	procedure SWDrawWrappedSprite (srcSpriteP: SpritePtr; dstFrameP: FramePtr; var srcRect: Rect; var dstRect: Rect);
	procedure SWEraseWrappedSprite (spriteWorldP: SpriteWorldPtr; var dstRect: Rect);
	procedure SWWrapWorldToScreen (spriteWorldP: SpriteWorldPtr);
	procedure SWCheckWrappedIdleSpriteOverlap (spriteWorldP: SpriteWorldPtr; idleSpriteP: SpritePtr; headActiveSpriteP: SpritePtr);
	procedure SWRedrawErasedIdleSprites (spriteWorldP: SpriteWorldPtr; headActiveSpriteP: SpritePtr; headIdleSpriteP: SpritePtr);
	procedure SWRedrawIdleSpritesInRect (spriteWorldP: SpriteWorldPtr; headIdleSpriteP: SpritePtr; var updateRect: Rect);

	procedure SWSetScrollingWorldMoveBounds (spriteWorldP: SpriteWorldPtr; var scrollRectMoveBounds: Rect);
	procedure SWSetScrollingWorldMoveProc (spriteWorldP: SpriteWorldPtr; worldMoveProcP: WorldMoveProcPtr; followSpriteP: SpritePtr);
	procedure SWSetSpriteWorldScrollDelta (spriteWorldP: SpriteWorldPtr; horizDelta: Integer; vertDelta: Integer);
	procedure SWMoveVisScrollRect (spriteWorldP: SpriteWorldPtr; horizPos: Integer; vertPos: Integer);
	procedure SWOffsetVisScrollRect (spriteWorldP: SpriteWorldPtr; horizOffset: Integer; vertOffset: Integer);
	procedure SWCalculateOffscreenScrollRect (spriteWorldP: SpriteWorldPtr);

{$ALIGN RESET}
{$POP}

{$IFC not undefined THINK_Pascal}
implementation
{$ENDC}
end.
